VERSION 5.00
Begin VB.Form frmEllipsoidArea 
   Caption         =   "Ellipsoid Zone Area"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4905
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   4905
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame fraResult 
      Caption         =   "Results"
      Height          =   1035
      Left            =   120
      TabIndex        =   11
      Top             =   4140
      Width           =   4635
      Begin VB.Label lblZ 
         Caption         =   "Result z"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   255
         Left            =   2760
         TabIndex        =   20
         Top             =   600
         Width           =   1815
      End
      Begin VB.Label lblPsi 
         Caption         =   "Result psi"
         Height          =   255
         Left            =   2760
         TabIndex        =   19
         Top             =   300
         Width           =   1815
      End
      Begin VB.Label zlbZ 
         Alignment       =   1  'Rechts
         Caption         =   "ellipsoid zone area  z="
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   600
         Width           =   2595
      End
      Begin VB.Label zlbPsi 
         Alignment       =   1  'Rechts
         Caption         =   "geocentric latitude  psi ="
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   300
         Width           =   2595
      End
   End
   Begin VB.Frame fraPhi 
      Caption         =   "Enter desired Latitude (degrees)"
      Height          =   1155
      Left            =   120
      TabIndex        =   8
      Top             =   2880
      Width           =   4635
      Begin VB.CommandButton Command1 
         Caption         =   "calculate"
         Height          =   315
         Left            =   2760
         TabIndex        =   14
         Top             =   660
         Width           =   1635
      End
      Begin VB.TextBox txtPhi 
         Height          =   285
         Left            =   2760
         TabIndex        =   10
         Text            =   "45,0"
         Top             =   280
         Width           =   1635
      End
      Begin VB.Label zlbPhi 
         Alignment       =   1  'Rechts
         Caption         =   "geographic latitude  phi ="
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   300
         Width           =   2595
      End
   End
   Begin VB.Frame fraEllipsoid 
      Caption         =   "Ellipsoid Data (Bessel 1841)"
      Height          =   1515
      Left            =   120
      TabIndex        =   3
      Top             =   1260
      Width           =   4635
      Begin VB.Label lblE 
         Caption         =   "Result e"
         Height          =   255
         Left            =   2760
         TabIndex        =   18
         Top             =   1140
         Width           =   1815
      End
      Begin VB.Label lblB 
         Caption         =   "Result b"
         Height          =   255
         Left            =   2760
         TabIndex        =   17
         Top             =   900
         Width           =   1815
      End
      Begin VB.Label lblF 
         Caption         =   "0,003342773182"
         Height          =   255
         Left            =   2760
         TabIndex        =   16
         Top             =   540
         Width           =   1815
      End
      Begin VB.Label lblA 
         Caption         =   "6377397,155"
         Height          =   255
         Left            =   2760
         TabIndex        =   15
         Top             =   300
         Width           =   1815
      End
      Begin VB.Label zlbE 
         Alignment       =   1  'Rechts
         Caption         =   "numeric eccentricity  e ="
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   1140
         Width           =   2595
      End
      Begin VB.Label zlbB 
         Alignment       =   1  'Rechts
         Caption         =   "semi-minor axis  b ="
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   900
         Width           =   2595
      End
      Begin VB.Label zlbF 
         Alignment       =   1  'Rechts
         Caption         =   "flattening  f ="
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   540
         Width           =   2595
      End
      Begin VB.Label zlbA 
         Alignment       =   1  'Rechts
         Caption         =   "semi-major axis  a ="
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   300
         Width           =   2595
      End
   End
   Begin VB.Frame fraLanguage 
      Caption         =   "Select Language"
      Height          =   1035
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4635
      Begin VB.OptionButton optLanguage 
         Caption         =   "deutsch"
         Height          =   255
         Index           =   1
         Left            =   1800
         TabIndex        =   2
         Top             =   600
         Width           =   2175
      End
      Begin VB.OptionButton optLanguage 
         Caption         =   "english"
         Height          =   255
         Index           =   0
         Left            =   1800
         TabIndex        =   1
         Top             =   300
         Value           =   -1  'True
         Width           =   2175
      End
   End
End
Attribute VB_Name = "frmEllipsoidArea"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim a   As Double 'semi-major axis [groe Halbachse]
Dim b   As Double 'semi-minor axis [kleine Halbachse]
Dim f   As Double 'flattening [Abplattung]
Dim e   As Double 'numeric eccentricity [numerische Exzentrizitt]
Dim phi As Double 'geographic latitude [geographischer Breitengrad]
Dim psi As Double 'geocentric latitude [geozentrischer Breitengrad]
Dim PI  As Double 'circle constant [Kreiszahl]

Private Sub Form_Load()
   Me.Top = (Screen.Height - Me.Height) / 2
   Me.Left = (Screen.Width - Me.Width) / 2
   'Reference ellipsoid Bessel 1841 [Referenzellipsoid Bessel 1841]
   a = 6377397.155
   f = 0.003342773182
   b = a - (a * f)
   e = Sqr(1 - (1 - f) ^ 2)
   PI = 4 * Atn(1)
   lblB.Caption = CStr(b)
   lblE.Caption = CStr(e)
End Sub

Private Sub Command1_Click()
   Dim ZoneArea As Double
   'Area of the surface of the ellipsoid between the equator and the desired geographic latitude PHI
   '[Flcheninhalt der Ellipsoidoberflche zwischen dem quator und dem gewnschten geographischem Breitengrad PHI]
   
   phi = CDbl(txtPhi.Text)
   psi = Atn((1 - e ^ 2) * Tan(Deg2Rad(phi)))
   
   ZoneArea = b ^ 2 * PI * (((Sin(psi) * Sqr(1 - e ^ 2 * Cos(psi) ^ 2 * (2 - e ^ 2))) / ((1 - e ^ 2) * (1 - e ^ 2 * Cos(psi) ^ 2))) + (1 / e) * Log(((e * Sin(psi)) + Sqr(1 - e ^ 2 * Cos(psi) ^ 2 * (2 - e ^ 2))) / (Sqr(1 - e ^ 2) * Sqr(1 - e ^ 2 * Cos(psi) ^ 2))))
   lblPsi.Caption = CStr(Rad2Deg(psi))
   lblZ.Caption = CStr(ZoneArea)
End Sub

Private Sub optLanguage_Click(Index As Integer)
   Call CheckLanguage
End Sub

Private Sub txtPhi_GotFocus()
   txtPhi.SelStart = 0
   txtPhi.SelLength = Len(txtPhi.Text)
End Sub

Private Sub txtPhi_KeyPress(KeyAscii As Integer)
   Select Case True
      Case KeyAscii = iDECIMAL
      Case KeyAscii = 13
         Call Command1_Click
      Case KeyAscii >= 48 And KeyAscii <= 57
      Case KeyAscii < 32
      Case Else
         KeyAscii = 0
   End Select
End Sub

Private Function Deg2Rad(ByVal Deg As Double) As Double
   'Deg = degree [Gradma]
   Deg2Rad = Deg * (PI / 180)
End Function

Public Function Rad2Deg(ByVal Rad As Double) As Double
   'Rad = radian [Bogenma]
   Rad2Deg = Rad * (180 / PI)
End Function

Private Sub CheckLanguage()
   Select Case True
      Case optLanguage(0).Value = True 'english [englisch]
         Me.Caption = "Ellipsoid Zone Area"
         fraLanguage.Caption = "Select Language"
         optLanguage(0).Caption = "english"
         optLanguage(1).Caption = "deutsch"
         fraEllipsoid.Caption = "Ellipsoid Data (Bessel 1841)"
         zlbA.Caption = "semi-major axis  a ="
         zlbF.Caption = "flattening  f ="
         zlbB.Caption = "semi-minor axis  b ="
         zlbE.Caption = "numeric eccentricity  e ="
         fraPhi.Caption = "Enter desired Latitude (degrees)"
         zlbPhi.Caption = "geographic latitude  phi ="
         fraResult.Caption = "Results"
         zlbPsi.Caption = "geocentric latitude  psi ="
         zlbZ.Caption = "ellipsoid zone area  z ="
      Case optLanguage(1).Value = True 'german [deutsch]
         Me.Caption = "Ellipsoid Zonenflche"
         fraLanguage.Caption = "Sprache auswhlen"
         optLanguage(0).Caption = "englisch"
         optLanguage(1).Caption = "german"
         fraEllipsoid.Caption = "Ellipsoid Daten (Bessel 1841)"
         zlbA.Caption = "grosse Halbachse  a ="
         zlbF.Caption = "Abplattung  f ="
         zlbB.Caption = "kleine Halbachse  b ="
         zlbE.Caption = "numerische Exzentrizitt  e ="
         fraPhi.Caption = "Breitengrad eingeben (Grad)"
         zlbPhi.Caption = "geographischer Breitengrad  phi ="
         fraResult.Caption = "Ergebnisse"
         zlbPsi.Caption = "geozentrischer Breitengrad  psi ="
         zlbZ.Caption = "Ellipsoid Zonenflche  z ="
   End Select
End Sub

